@echo off
rem PDF-WINNT.BAT
rem -------------
rem Batch-Datei zum Rumborak PDF-Writer
rem
rem Erstellung von PDF-Dateien auf dem Desktop mit automatischem Dateinamen
rem
rem Version 1.0
rem fr Windows NT/2000/XP
rem
rem 2004 von Wolfgang Reszel

rem Pfad zum Rumborak-Verzeichnis
set RUMBORAK=c:\gs\Rumborak

rem -- -- Sonderzeichen aus Dateinamen entfernen -- -- -- -- -- -- --
set REDMON_DOCNAME=%REDMON_DOCNAME:\=_%
set REDMON_DOCNAME=%REDMON_DOCNAME:/=_%
set REDMON_DOCNAME=%REDMON_DOCNAME::=_%
set REDMON_DOCNAME=%REDMON_DOCNAME:?=_%
set REDMON_DOCNAME=%REDMON_DOCNAME:"=_%
set REDMON_DOCNAME=%REDMON_DOCNAME:<=_%
set REDMON_DOCNAME=%REDMON_DOCNAME:>=_%
set REDMON_DOCNAME=%REDMON_DOCNAME:|=_%

rem Dateinamenzusatz von Word und Powerpoint entfernen
set REDMON_DOCNAME=%REDMON_DOCNAME:Microsoft Word - =%
set REDMON_DOCNAME=%REDMON_DOCNAME:Microsoft Powerpoint - =%
set REDMON_DOCNAME=%REDMON_DOCNAME:Microsoft PowerPoint - =%

rem * aus Dateinamen entfernen: 1.
if "%REDMON_DOCNAME:~0,1%" EQU "*" (
  set REDMON_DOCNAME=_%REDMON_DOCNAME:~1%
)

rem * aus Dateinamen entfernen: 2.
:loop
for /f "tokens=1* delims=*" %%a in ("%REDMON_DOCNAME%") do (
  if "%%b" NEQ "" (
    set REDMON_DOCNAME=%%a_%%b
    goto :loop
  )
)

rem % aus Dateinamen entfernen: 3.
:loop2
for /f "tokens=1* delims=%%" %%a in ("%REDMON_DOCNAME%") do (
  if "%%b" NEQ "" (
    set REDMON_DOCNAME=%%a_%%b
    goto :loop2
  )
)

rem -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

rem leeren Dokumentnamen ersetzen
if "%REDMON_DOCNAME%" EQU "" (
  set REDMON_DOCNAME=untitled
)

rem Dateierweiterung entfernen
for %%I IN ("%REDMON_DOCNAME%") DO @set NAME=%%~nI

rem Dateiname mit Datum/Uhrzeit versehen (rem entfernen)
rem for /f "tokens=1,2,3 delims=. " %%A in ('DATE /T') do set D=%%C-%%B-%%A
rem for /f "tokens=1,2 delims=:" %%A in ('TIME /T') do set T=%%A%%B
rem set NAME=%NAME% %D% %T%

rem Variablen holen
call %RUMBORAK%\variablen.bat

rem Zielverzeichnis
set VERZEICHNIS=%DESKTOP%

rem Temporre Datei
set TEMPFILE=%TEMP%\pdftmp.ps

rem Prfen ob Aufruf ber Redrun oder direkt aus Redmon
if "%1"=="" goto redfile

rem Aufruf durch Redrun
set TEMPFILE=%1
goto noredfile

rem Aufruf direkt aus Redmon
:redfile
%GSMAIN%\redmon\redfile.exe %TEMPFILE%

:noredfile

rem Ghostscript zur PDF-Erstellung aus der Temp-Datei starten
%GS% @%RUMBORAK%\pdf.rsp -dJobserver -sOutputFile="%VERZEICHNIS%\%NAME%.pdf" %TEMPFILE% "%RUMBORAK%\pdfmarks.ps" > "%VERZEICHNIS%\%NAME%.log"

rem Temporre Datei lschen
del %TEMPFILE%

rem Prfe ob Fehler im Log-File stehen
findstr "Can't" "%VERZEICHNIS%\%NAME%.log"
if %ERRORLEVEL% == 0 goto Warning
findstr "Error" "%VERZEICHNIS%\%NAME%.log"
if %ERRORLEVEL% == 0 goto NOTOK

rem Keine Fehler, Log-File lschen
:OK
del "%VERZEICHNIS%\%NAME%.log"

rem .. Acrobat mir der PDF-Datei aufrufen
:Acrobat
start "Acrobat" "%VERZEICHNIS%\%NAME%.pdf"
goto END

rem Warnungen im Log-File, Logfile und PDF-Datei anzeigen
:Warning
start write "%VERZEICHNIS%\%NAME%.log"
goto Acrobat

rem Fehlermeldungen im Log-File, nur Logfile anzeigen
:NOTOK
start write "%VERZEICHNIS%\%NAME%.log"

rem Ende
:END
